
//rlyeh, based on ASpectrum

#include "shared.h"


extern void ExitEmulator (void);
extern Z80Regs *spectrumZ80;
extern int cycle;
//extern volatile int frame_counter;
//extern volatile int target_cycle;
//extern volatile int last_fps;
extern void target_incrementor (void);
extern void count_frames (void);


int DrawZXVRAMContended(int y, int target_tstates);

int full_screen=0;


// hardware definitions for spectrum 48K
tipo_hwopt hwopt = { 0xFF, 24, 128, 24, 48, 224, 16, 48, 192, 48, 8,
  224, 64, 192, 56, 24, 128, 72
};



int v_res = 240;
int v_border = 24;

char SpectrumFlashFlag=0;

void DrawZXVRAM(int y);


/*-----------------------------------------------------------------
 CreateVideoTables ( void );
 Creates tables for direct access to videomemory pixels and attr.
------------------------------------------------------------------*/

unsigned short Pixeles[192],Atributos[192];

void CreateVideoTables ( void )
{
   int y;

   for( y=0; y < 192; y++)
   {
    Pixeles[y]   = ((y & 0xC0) << 5) + ((y & 0x7) << 8) + ((y & 0x38) << 2);
    Atributos[y] = (32 * (y >> 3));
   }
}





/*-----------------------------------------------------------------
 Redraw the entire screen from the speccy's VRAM.
 It reads the from the 16384 memory address the bytes of the
 VideoRAM needed to rebuild the screen and the border.
------------------------------------------------------------------*/

void
RunAndDisplayScreen(Z80Regs * regs, int do_skip)
{
  int target_tstate, current_tstate;
  int scanl;

  if(!do_skip)
  {

            // upper border (63 or 64... 48 of them are border, rest can be border or retrace)
            hwopt.port_ff = 0xFF;

            target_tstate = ( model<ZX_128 ? TIMING_48+1 : TIMING_128+1 ) - v_border * hwopt.ts_line ;

            Z80Run (spectrumZ80, target_tstate - (spectrumZ80->IPeriod - spectrumZ80->ICount) );

              // visible upper border (24 lines in our case)        
	      for (scanl = 0; scanl < v_border; scanl++)
		{
                  target_tstate+=hwopt.ts_line;
                  Z80Run (spectrumZ80, target_tstate - (spectrumZ80->IPeriod - spectrumZ80->ICount) );

                  DrawZXVRAM(scanl);
		}

	      // Now run the emulator for all the real screen (192 lines)
              for (scanl = 0 + v_border; scanl < 192 + v_border; scanl++)
		{
		  // left border
		  hwopt.port_ff = 0xFF;
                  target_tstate+=hwopt.ts_lebo;
                  Z80Run (spectrumZ80, target_tstate - (spectrumZ80->IPeriod - spectrumZ80->ICount) );

		  // screen
                  hwopt.port_ff = 0x00;

#ifdef DISPLAY_BY_CYCLE

                  target_tstate=DrawZXVRAMContended(scanl,target_tstate);

                  // right border + retrace
		  hwopt.port_ff = 0xFF;
                  target_tstate+=hwopt.ts_ribo+hwopt.ts_hore;
                  Z80Run (spectrumZ80, target_tstate - (spectrumZ80->IPeriod - spectrumZ80->ICount) );

#else

                  target_tstate+=hwopt.ts_grap;
                  Z80Run (spectrumZ80, target_tstate - (spectrumZ80->IPeriod - spectrumZ80->ICount) );

                  // right border + retrace
		  hwopt.port_ff = 0xFF;
                  target_tstate+=hwopt.ts_ribo+hwopt.ts_hore;
                  Z80Run (spectrumZ80, target_tstate - (spectrumZ80->IPeriod - spectrumZ80->ICount) );

                  DrawZXVRAM(scanl);
#endif

                 }

	      // visible bottom border
	      hwopt.port_ff = 0xFF;
              for (scanl = 192 + v_border; scanl < 192 + v_border + v_border /*v_res*/; scanl++)
		{
                  target_tstate+=hwopt.ts_line;
                  Z80Run (spectrumZ80, target_tstate - (spectrumZ80->IPeriod - spectrumZ80->ICount) );

                  DrawZXVRAM(scanl);
		}

              // the last lines (56+16 - border)
	      // Run it for 56 lines covering bottom border and ray return
              Z80Run (spectrumZ80, spectrumZ80->ICount);


          sync_pixels();


  }

  else

  {
	      // no visible upper border
	      target_tstate =
		(hwopt.ts_line *
		 (hwopt.line_upbo + hwopt.line_poin - v_border)) -
		hwopt.ts_lebo;
	      current_tstate = spectrumZ80->IPeriod - spectrumZ80->ICount;
	      hwopt.port_ff = 0xFF;
              Z80Run (spectrumZ80, target_tstate - current_tstate);

	      // visible upper border         
              for (scanl = 0; scanl < v_border ; scanl++)
		{
                  target_tstate += hwopt.ts_line;
		  current_tstate = spectrumZ80->IPeriod - spectrumZ80->ICount;
                  Z80Run (spectrumZ80, target_tstate - current_tstate);

                  *zx_bordercolour++=/*spectrumZ80->*/BorderColor;
		}

	      // Now run the emulator for all the real screen (192 lines)
	      for (scanl = 0; scanl < 192; scanl++)
		{
		  // left border
		  target_tstate += hwopt.ts_lebo;
		  current_tstate = spectrumZ80->IPeriod - spectrumZ80->ICount;
		  hwopt.port_ff = 0xFF;
                  Z80Run (spectrumZ80, target_tstate - current_tstate);

		  // screen
		  target_tstate += hwopt.ts_grap;
		  current_tstate = spectrumZ80->IPeriod - spectrumZ80->ICount;
		  hwopt.port_ff = 0x00;
                  Z80Run (spectrumZ80, target_tstate - current_tstate);

		  // right border
		  target_tstate += (hwopt.ts_ribo + hwopt.ts_hore);
		  current_tstate = spectrumZ80->IPeriod - spectrumZ80->ICount;
		  hwopt.port_ff = 0xFF;
		  Z80Run (spectrumZ80, target_tstate - current_tstate);

                  *zx_bordercolour++=/*spectrumZ80->*/BorderColor;
                }

	      // visible bottom border
	      hwopt.port_ff = 0xFF;
	      for (scanl = 192 + v_border; scanl < v_res; scanl++)
		{
		  target_tstate += hwopt.ts_line;
		  current_tstate = spectrumZ80->IPeriod - spectrumZ80->ICount;
		  Z80Run (spectrumZ80, target_tstate - current_tstate);

                  *zx_bordercolour++=/*spectrumZ80->*/BorderColor;
		}

	      // the last lines (56+16 lines - border)
	      // Run it for 56 lines covering bottom border and ray return
	      Z80Run (spectrumZ80, spectrumZ80->ICount);
  }


}

/*-------------------------------------------------------------------------*/
unsigned char scanline[320];

void
displayborderscanline (int y)
{
 int len=320;

 LCDs8=pixel(0,y);

 while(len--)
  { *LCDs8=/*spectrumZ80->*/BorderColor; LCDs8+=pixel_inc; }
}


/*-------------------------------------------------------------------------*/
void
displayscanline2 (int y, int f_flash, Z80Regs * regs)
{
  int x, row, col, dir_p, dir_a, pixeles, tinta, papel, atributos;
  extern int v_border;

  int len;

  row = y + v_border;		// 4 & 32 = graphical screen offset
  col = 32;			// 32+256+32=320  4+192+4=200  (res=320x200)


  LCDs8=pixel(288,row); len=32;
  while(len--) { *LCDs8=/*spectrumZ80->*/BorderColor; LCDs8+=pixel_inc; }

  LCDs8=pixel(0,row); len=32;
  while(len--) { *LCDs8=/*spectrumZ80->*/BorderColor; LCDs8+=pixel_inc; }

//  dir_p = 0x4000 + ((y & 0xC0) << 5) + ((y & 0x7) << 8) + ((y & 0x38) << 2);
//  dir_a = 0x5800 + (32 * (y >> 3));

  dir_p = 0x4000 + Pixeles[y];
  dir_a = 0x5800 + Atributos[y];

  for (x = 0; x < 32; x++)
    {
      pixeles   = (int)Z80MEMREAD(dir_p); dir_p++;
      atributos = (int)Z80MEMREAD(dir_a); dir_a++;

      if (((atributos & 0x80) == 0) || (f_flash == 0))
	{
	  tinta = (atributos & 0x07) + ((atributos & 0x40) >> 3);
	  papel = (atributos & 0x78) >> 3;
	}
      else
	{
	  papel = (atributos & 0x07) + ((atributos & 0x40) >> 3);
	  tinta = (atributos & 0x78) >> 3;
	}


      *LCDs8=((pixeles & 0x80) ? tinta : papel); LCDs8+=pixel_inc; 
      *LCDs8=((pixeles & 0x40) ? tinta : papel); LCDs8+=pixel_inc; 
      *LCDs8=((pixeles & 0x20) ? tinta : papel); LCDs8+=pixel_inc; 
      *LCDs8=((pixeles & 0x10) ? tinta : papel); LCDs8+=pixel_inc; 
      *LCDs8=((pixeles & 0x08) ? tinta : papel); LCDs8+=pixel_inc; 
      *LCDs8=((pixeles & 0x04) ? tinta : papel); LCDs8+=pixel_inc; 
      *LCDs8=((pixeles & 0x02) ? tinta : papel); LCDs8+=pixel_inc; 
      *LCDs8=((pixeles & 0x01) ? tinta : papel); LCDs8+=pixel_inc; 
    }
}


/*-----------------------------------------------------------------
 Redraw a single scanline of screen from the speccy's VRAM.
------------------------------------------------------------------*/
void
DisplayScanLine (int linea, Z80Regs * regs)
{
  displayscanline2 (linea, 0, regs);
}






int scan_convert[192] = {
   0<<5,8<<5,16<<5,24<<5,32<<5,40<<5,48<<5,56<<5,
   1<<5,9<<5,17<<5,25<<5,33<<5,41<<5,49<<5,57<<5,
   2<<5,10<<5,18<<5,26<<5,34<<5,42<<5,50<<5,58<<5,
   3<<5,11<<5,19<<5,27<<5,35<<5,43<<5,51<<5,59<<5,
   4<<5,12<<5,20<<5,28<<5,36<<5,44<<5,52<<5,60<<5,
   5<<5,13<<5,21<<5,29<<5,37<<5,45<<5,53<<5,61<<5,
   6<<5,14<<5,22<<5,30<<5,38<<5,46<<5,54<<5,62<<5,
   7<<5,15<<5,23<<5,31<<5,39<<5,47<<5,55<<5,63<<5,
		   
   64<<5,72<<5,80<<5,88<<5,96<<5,104<<5,112<<5,120<<5,
   65<<5,73<<5,81<<5,89<<5,97<<5,105<<5,113<<5,121<<5,
   66<<5,74<<5,82<<5,90<<5,98<<5,106<<5,114<<5,122<<5,
   67<<5,75<<5,83<<5,91<<5,99<<5,107<<5,115<<5,123<<5,
   68<<5,76<<5,84<<5,92<<5,100<<5,108<<5,116<<5,124<<5,
   69<<5,77<<5,85<<5,93<<5,101<<5,109<<5,117<<5,125<<5,
   70<<5,78<<5,86<<5,94<<5,102<<5,110<<5,118<<5,126<<5,
   71<<5,79<<5,87<<5,95<<5,103<<5,111<<5,119<<5,127<<5,

   128<<5,136<<5,144<<5,152<<5,160<<5,168<<5,176<<5,184<<5,
   129<<5,137<<5,145<<5,153<<5,161<<5,169<<5,177<<5,185<<5,
   130<<5,138<<5,146<<5,154<<5,162<<5,170<<5,178<<5,186<<5,
   131<<5,139<<5,147<<5,155<<5,163<<5,171<<5,179<<5,187<<5,
   132<<5,140<<5,148<<5,156<<5,164<<5,172<<5,180<<5,188<<5,
   133<<5,141<<5,149<<5,157<<5,165<<5,173<<5,181<<5,189<<5,
   134<<5,142<<5,150<<5,158<<5,166<<5,174<<5,182<<5,190<<5,
   135<<5,143<<5,151<<5,159<<5,167<<5,175<<5,183<<5,191<<5
};











//int parity_scan=0;



void DrawZXVRAM(int y)
{
 register byte *VRAM,*VRAMPal,border;
 register int x;
 volatile byte *gp32offset;   

// y+=parity_scan;

gp32offset=(byte *)Picture+(y*320);   /*avoids first gp32offset+=240 precedence*/ 
 // y = 0-311 TV Scanline

#ifdef DISPLAY_BY_SCANLINE
 border = /*spectrumZ80->*/BorderColor;
#else
 border = zx_bordercolours[y];
#endif


 //LCDs8=pixel(288,row); len=32;
 //while(len--) { *LCDs8=/*spectrumZ80->*/BorderColor; LCDs8+=pixel_inc; }

 if((y<24)||(y>24+192-1)) 
 {
 if(!full_screen)
 for(x=0;x<320;x++)
  *(gp32offset++)=border; 

 return;
 }

 y-=24;
if(full_screen) gp32offset=(byte *)Picture+(y*320); 
   VRAM=(byte *)&RAM_pages[(pagination_128 & 8 ? 0x4000*7 : 0x4000*5)];
VRAMPal=VRAM+6144+((y&0xF8)<<2);
  VRAM+=scan_convert[y];

if(!full_screen)
 for(x=0;x<32;x++)  
  *(gp32offset++)=border;

 for(x=0;x<32;x++)
 {
  register byte fg,bg;

  if( ((*VRAMPal)&0x80) && SpectrumFlashFlag ) //if flash...
   { bg=((*VRAMPal)&0x7)+(((*VRAMPal)>>3)&0x8); fg=(((*VRAMPal)>>3)&0x0F); }  
  else
   { fg=((*VRAMPal)&0x7)+(((*VRAMPal)>>3)&0x8); bg=(((*VRAMPal)>>3)&0x0F); }
  
  *(gp32offset++)=*VRAM & 0x80 ? fg : bg;
  *(gp32offset++)=*VRAM & 0x40 ? fg : bg;
  *(gp32offset++)=*VRAM & 0x20 ? fg : bg;
  *(gp32offset++)=*VRAM & 0x10 ? fg : bg;
  *(gp32offset++)=*VRAM & 0x8  ? fg : bg;
  *(gp32offset++)=*VRAM & 0x4  ? fg : bg;
  *(gp32offset++)=*VRAM & 0x2  ? fg : bg;
  *(gp32offset++)=*VRAM & 0x1  ? fg : bg;

  VRAM++;
  VRAMPal++;
 }
if(!full_screen)
 for(x=0;x<32;x++)  //29!!!
  *(gp32offset++)=border;
}




int DrawZXVRAMContended(int y, int target_tstate)
{
 register byte *VRAM,*VRAMPal,border;
 register int x, cycles=spectrumZ80->ICount-128; 
volatile byte *gp32offset;

 //y+=parity_scan;

gp32offset=(byte *)Picture+(y*320);   /*avoids first gp32offset+=240 precedence*/ 
 // y = 0-311 TV Scanline

 //LCDs8=pixel(288,row); len=32;
 //while(len--) { *LCDs8=/*spectrumZ80->*/BorderColor; LCDs8+=pixel_inc; }

 if((y<24)||(y>24+192-1)) 
 {if(!full_screen)
 for(x=0;x<320;x++)
  *(gp32offset++)=/*spectrumZ80->*/BorderColor;

 return;
 }

 y-=24;
if(full_screen) gp32offset=(byte *)Picture+(y*320); 

  //set page 5 or page 7 (48 or 128 mode), and emulates snow effect if needed
  // VRAM+= (spectrumZ80->I & 0xC0 == 0x40 ? spectrumZ80->R.W : 0 )] <- snow effect, apply ever iteration at main graphics loop below
  // 
 VRAM    = (byte *)&RAM_pages[(pagination_128 & 8 ? 0x4000*7 : 0x4000*5) ];
 VRAMPal = VRAM+6144+((y&0xF8)<<2);
 VRAM   += scan_convert[y];
if(!full_screen)
 for(x=0;x<32;x++)  
  *(gp32offset++)=/*spectrumZ80->*/BorderColor;

 for(x=0;x<32;x++)
 {
  register byte fg,bg;

  if( ((*VRAMPal)&0x80) && SpectrumFlashFlag ) //if flash...
   { bg=((*VRAMPal)&0x7)+(((*VRAMPal)>>3)&0x8); fg=(((*VRAMPal)>>3)&0x0F); }  
  else
   { fg=((*VRAMPal)&0x7)+(((*VRAMPal)>>3)&0x8); bg=(((*VRAMPal)>>3)&0x0F); }

  *(gp32offset++)=*VRAM & 0x80 ? fg : bg;
  *(gp32offset++)=*VRAM & 0x40 ? fg : bg;
  *(gp32offset++)=*VRAM & 0x20 ? fg : bg;
  *(gp32offset++)=*VRAM & 0x10 ? fg : bg;
  *(gp32offset++)=*VRAM & 0x8  ? fg : bg;
  *(gp32offset++)=*VRAM & 0x4  ? fg : bg;
  *(gp32offset++)=*VRAM & 0x2  ? fg : bg;
  *(gp32offset++)=*VRAM & 0x1  ? fg : bg;

  VRAM++;
  VRAMPal++;

  /*
  // cycle exact ok para VECTRON
  if(spectrumZ80->ICount>cycles)
  {
   target_tstate+=4;
   Z80Run (spectrumZ80, target_tstate - (spectrumZ80->IPeriod - spectrumZ80->ICount) );
  }
  */
 }

   target_tstate+=128;
   Z80Run (spectrumZ80, target_tstate - (spectrumZ80->IPeriod - spectrumZ80->ICount) );

if(!full_screen)
 for(x=0;x<32;x++)  //29!!!
  *(gp32offset++)=/*spectrumZ80->*/BorderColor;

//spectrumZ80->ICount+=4; //border granularity

 return target_tstate;
}



