/*  textread (spanish) v1.1 for GP2X

    Copyright (C) 2006  Hermes/PS2Reality  * Made in Vallecas - Madrid (Spain)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/





#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <math.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>

#include "minimal.h"
#include "cpuctrl.h"

#define USE_ZIP


#ifdef USE_ZIP
#include "zip.h"
#endif



#include "font2.h"

extern unsigned char msx[];  // define la fuente externa usada para dibujar letras y numeros 

/*********************************************************************/
/* GP2X System                                                       */
/*********************************************************************/
int dclock;
int gp2x_nKeys=0,new_key=0,old_key=0;
int gp2x_speed=133;
void set_speed_clock()
{
int div;
div=(gp2x_speed*14)/200;
if(div>63) div=63;
//if((dclock & 192)==64) // si es reloj de sistema
	 set_display_clock_div(64 | div /*(16+8*(gp2x_speed>=220))*/);
set_FCLK(gp2x_speed);set_DCLK_Div(0);set_920_Div(0);

}






/****************************************************************************************************************************************/
// PANTALLA
/****************************************************************************************************************************************/


unsigned char COLORFONDO=0; // color de fondo (vaya noticia :P)

unsigned char mypalette_rgb[7][3]={
{0x00,0x0,0x00},
{0xff,0x00,0x00},
{0x00,0xff,0x00},
{0x00,0x00,0xff},
{0xff,0xff,0x00},
{0x00,0xff,0xff},
{0x00,0x00,0x00},
};

unsigned char background[3]={255,255,255};
void set_mypalette()
{
int n;
for(n=0;n<7;n++)
gp2x_video_RGB_color8(mypalette_rgb[n][0],mypalette_rgb[n][1],mypalette_rgb[n][2],n);

gp2x_video_RGB_color8(190,190,60,254);
gp2x_video_RGB_color8(background[0],background[1],background[2],255);
gp2x_video_RGB_setpalette();


}

void ClearScreen(unsigned char c) // se usa para 'borrar' la pantalla virtual con un color
{
int n;

for(n=0;n<320*240;n++)
	{
	gp2x_screen8[n]=c;
	}

}


void v_putchar( unsigned x, unsigned y, unsigned char color, unsigned char ch) // rutina usada para dibujar caracteres (coordenadas de 8x8)
{
   volatile int 	i,j;
   volatile unsigned char	*font;
  volatile unsigned char col,col2;
  volatile unsigned char *p;
   if(x>=40 || y>=30) return;

  

col=color;
col2=COLORFONDO;

  
   font = &msx[ (int)ch * 8];
   p=&gp2x_screen8[(y*320*8)+(x<<3)];
   if(col!=col2)
   {
   for (i=0; i < 8; i++, font++)
		{  
		 for (j=0; j < 8; j++)
          {
          if ((*font & (128 >> j))) p[j]=col;
			  
			else  p[j]=col2;
          }
	  p+=320;
	 }
   }
   else
   {
   for (i=0; i < 8; i++, font++)
		{  
		 for (j=0; j < 8; j++)
          {
          if ((*font & (128 >> j))) p[j]=col;
			  
          }
	  p+=320;
	 }
   }
}

// display array of chars

int v_breakcad=40;
int v_forcebreakcad=0;
int lastx=0;
void v_putcad(int x,int y,unsigned color,char *cad)  // dibuja una cadena de texto
{
int n=0;	
while(cad[0]!=0) {if(n==v_breakcad) break; v_putchar(x,y,color,cad[0]);cad++;x++;n++;}
if(v_forcebreakcad)
	{
	while(1) {if(x>=40 || n==v_breakcad) break; v_putchar(x,y,color,' ');cad++;x++;n++;}
	}
lastx=x;
}



void t_putchar( unsigned x, unsigned y, unsigned char color, unsigned char ch) // rutina usada para dibujar caracteres del texto (coordenadas de pixels)
{
   volatile int n,m;
   unsigned short *font=&font2;
   volatile unsigned short va;
   volatile unsigned char col;
   volatile unsigned char *p;

   if(x>=320 || y>=240) return;
   if(ch<32) return;
    

col=color;
 font += ((int)(ch-32)) <<4;
   p=&gp2x_screen8[(y*320)+(x)];
for(n=0;n<16;n++)
	{
	va=*font++;
	for(m=0;m<8;m++)
		{
		if(va & (32768+16384)) p[m]=col;
		va<<=2;
		}
     p+=320;
	}


 
}
void t_putchar2( unsigned x, unsigned y, unsigned char color, unsigned char ch) // rutina usada para dibujar caracteres del texto (coordenadas de pixels)
{
   volatile int n,m;
   unsigned short *font=&font2;
   volatile unsigned short va;
   volatile unsigned char col,col2;
   volatile unsigned char *p;

x<<=3;y<<=3;
   if(x>=320 || y>=240) return;
   if(ch<32) return;
    

col=color;
col2=COLORFONDO;
 font += ((int)(ch-32)) <<4;
   p=&gp2x_screen8[(y*320)+(x)];
for(n=0;n<16;n++)
	{
	va=*font++;
	for(m=0;m<8;m++)
		{
		if(va & (32768+16384)) p[m]=col; else p[m]=col2;
		va<<=2;
		}
     p+=320;
	}


 
}

void t_putcad(int x,int y,unsigned color,char *cad)  // dibuja una cadena de texto
{
int n=0;	

while(cad[0]!=0) {if(n==v_breakcad) break; t_putchar2(x,y,color,cad[0]);cad++;x++;n++;}
if(v_forcebreakcad)
	{
	while(1) {if(x>=40 || n==v_breakcad) break; t_putchar2(x,y,color,' ');cad++;x++;n++;}
	}
lastx=x;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// SONIDO
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int		ds_nBits		=16;
int		ds_nChannels	= 1;
int		ds_nSampleRate	= 44100; 





int gp2x_sound_frame(void *unused, void *stream, int samples)
{

int n;
short *pu;

pu=stream;

	if(samples>11025) samples=11025;
	for(n=0;n<(samples);n++)
		{*pu++=0;if(ds_nChannels==2) *pu++=0;}
	return samples;
	
}







/***************************************************************************/
// seleccion de roms y otras pantallas 
/***************************************************************************/


#define MAX_ENTRY 512

char files[MAX_ENTRY][257];
char is_directory[MAX_ENTRY];
int nfiles=0;
int ndirs=0;
char path_file[256]="";
char device[256]="/mnt/sd/";

int is_ext(char *a,char *b) // compara extensiones
{
int n,m;
m=0;n=0;


while(a[n]!=0) {if(a[n]=='.') m=n; n++;}
n=0;
while(b[n]!=0) {if(a[m]!=b[n]) return 0; m++; n++;}
if(a[m]==0) return 1;
return 0;
}

void read_list_file(unsigned char *dirname)
{DIR *fd;
static struct dirent *direntp;

static char swap[257],sw;
int n,m,f;

nfiles = 0;ndirs=0;
if(dirname)
	{if(dirname[0] == '.') 
	  {
	  n=0;while(path_file[n]!=0) n++; n--;
	  while(path_file[n]!='/' && n>0) n--;
        if(n<=0)  path_file[0]=0;
	  else 
	  if(path_file[n]=='/') path_file[n]=0;
      if(path_file[0]!=0)
	   sprintf(swap, "%s%s/",device ,path_file);
	  else strcpy(swap,device);

      }
     else {if(path_file[0]!=0) strcat(path_file,"/");strcat(path_file,dirname);sprintf(swap, "%s%s/",device ,path_file);}
	
	}
else {if(path_file[0]!=0) sprintf(swap, "%s%s/",device ,path_file); else strcpy(swap,device);}



fd = opendir(swap);

if(fd != NULL) 
	{
	
	while(nfiles < MAX_ENTRY)
		{is_directory[nfiles]=0;
		direntp=readdir(fd);
	    if(direntp==NULL) break;
		//if(direntp->d_name[0] == '.' && direntp->d_name[1]==0) continue;
        
		
	   sprintf(&files[nfiles][0], "%s",direntp->d_name);
		if( direntp->d_type & DT_DIR) 
			{ndirs++;is_directory[nfiles]=1; 
		     
		    }
		/*else 
		
		if(!(is_ext(&files[nfiles][0],".txt") ||is_ext(&files[nfiles][0],".TXT")
			
		   ) ) continue;
		*/
		nfiles++;
		}
	
	closedir(fd);	
	}
	

for(n=0;n<(nfiles);n++) //ordena
for(m=n+1;m<nfiles;m++)
	{f=0;
 
	
		if(is_directory[m]==1 && is_directory[n]==0) f=1;
	    if(f==0) if(is_directory[m]==is_directory[n]) if(strcmp(&files[m][0],&files[n][0])<0) f=1;
		if(f)
		{f=0;
		sw=is_directory[m];
		is_directory[m]=is_directory[n];
		is_directory[n]=sw;
		memcpy(swap,&files[m][0],256);
		memcpy(&files[m][0],&files[n][0],256);
		memcpy(&files[n][0],swap,256);
		}
	}

} 

char * get_name_short(char *name) // devuelve el nombre del fichero recortado a 20 caracteres
{
static unsigned char name2[64];
int n,m;
m=0;n=-1;

while(name[m]!=0) {if(name[m]=='/') n=m;m++;}
n++;
for(m=0;m<38;m++)
	{
	name2[m]=name[n];
	if(name[n]==0) break;
	n++;
	}
name2[m]=0;
return name2;
}

char * get_name(char *name) // devuelve el nombre del fichero completo
{
static unsigned char name2[256];
int n,m;
m=0;n=-1;

while(name[m]!=0) {if(name[m]=='/') n=m;m++;}
n++;
for(m=0;m<255;m++)
	{
	name2[m]=name[n];
	if(name[n]==0) break;
	n++;
	}
name2[m]=0;
return name2;
}




int get_file()
{
static int init=1;
static  int posfile=0;
unsigned char cad[256];
int n,m,y,f;
static int bright=1;
int old_speed=gp2x_speed;
unsigned new_key=0,old_key=0;
background[0]=200;background[1]=200;background[2]=140;
set_mypalette();
if(init)
	{
   read_list_file(0);if(nfiles)  init=0; else init=1;
   posfile=0;
	}

while(gp2x_nKeys & (GP2X_X | GP2X_PUSH | GP2X_SELECT)) gp2x_nKeys=gp2x_joystick_read(); // para quieto!!

if(posfile>=nfiles) posfile=0;
COLORFONDO=255;  gp2x_video_RGB_flip(0);
f=0;
while(1)
	{
	
	
	gp2x_video_waitvsync();gp2x_video_RGB_flip(0);ClearScreen(COLORFONDO);
    sprintf(cad,"FILE LIST (%u)          ",nfiles-ndirs);
    COLORFONDO=254;
    v_putcad(0,0,3,cad);v_putcad(20,0,3,"Press SELECT to Exit");
	COLORFONDO=255;
    m=0;

	for(n=posfile-10;n<posfile+25;n++)
		{if(n<0) continue;
	     if(n>=nfiles) break;
		 if(m>24) break;
		 if(n==posfile) COLORFONDO=2; else COLORFONDO=255;
		v_breakcad=38;v_forcebreakcad=1;
		if(is_directory[n])
			{
			sprintf(cad,"<%s>",get_name_short(&files[n][0]));
			t_putcad(0,(m+3),3,cad);
			}
		else t_putcad(1,(m+3),0,get_name_short(&files[n][0]));
		v_breakcad=40;v_forcebreakcad=0;
		COLORFONDO=255;
		 m++;m++;
		}
	
	

    y=6;
	

	

    gp2x_nKeys=gp2x_joystick_read();
	
	new_key=gp2x_nKeys & (~old_key);
	old_key=gp2x_nKeys;
    if(!(old_key  & (GP2X_UP | GP2X_DOWN))) f=0;
	if(old_key  & GP2X_UP)
		{
		if(f==0) f=2;
		else if(f & 1) f=2;
		else {f+=2;if(f>40) {f=38;new_key|=GP2X_UP;}}
		}
	if(old_key  & GP2X_DOWN)
		{
		if(f==0) f=1;
		else if(!(f & 1)) f=1;
		else {f+=2;if(f>41) {f=39;new_key|=GP2X_DOWN;}}
		}
		
	

if(nfiles>0) if(new_key & (GP2X_A | GP2X_PUSH | GP2X_X)) 
		{
		
		if(!is_directory[posfile]) {return posfile;}
          else
			{
			 read_list_file(get_name(&files[posfile][0]));if(nfiles)  init=0; else init=1;posfile=0;
			}
		}









if((new_key & GP2X_UP)) {posfile--;if(posfile<0) posfile=nfiles-1;}
if((new_key & GP2X_DOWN)){posfile++;if(posfile>=nfiles) posfile=0;} 
if(new_key & GP2X_SELECT) {return -1;}

	}

return -1;
}


/****************************************************************************************************************/
// credits
/****************************************************************************************************************/

void credits()
{

int y;
int count=30*6;

background[0]=200;background[1]=200;background[2]=140;
set_mypalette();
COLORFONDO=255;  gp2x_video_RGB_flip(0);
while(count>0)
	{
	count--;
	gp2x_video_waitvsync();gp2x_video_RGB_flip(0);ClearScreen(COLORFONDO);
    
	y=2;
    t_putcad((40-16)/2,y,3,"TextReader v1.1");y+=3;
	t_putcad((40-24)/2,y,3,"* With Spanish Charset *");y+=4;
    t_putcad((40-19)/2,y,0,"Made by Hermes PS2R");y+=3;
    y+=2;
	t_putcad((40-21)/2,y,0,"Based on the work of:");y+=3;
	t_putcad((40-20)/2,y,0,"rlyeh / GPX2 Min Lib");y+=3;
	y+=2;
	
   
    gp2x_nKeys=gp2x_joystick_read();

	if((gp2x_nKeys & (GP2X_A | GP2X_B | GP2X_X | GP2X_Y | GP2X_START))) 
		{while(gp2x_nKeys & (GP2X_A | GP2X_B | GP2X_X | GP2X_Y | GP2X_START)) gp2x_nKeys=gp2x_joystick_read();return;}

	}
while(gp2x_nKeys & (GP2X_A | GP2X_B | GP2X_X | GP2X_Y | GP2X_START)) gp2x_nKeys=gp2x_joystick_read();

}






unsigned oldtime=0;


int text_cod=0; // codificacin de texto

int cur_line=0;
int cur_page=0;
int cur_mark=0;

unsigned char *text=0;
int len_text=0;
int pos_text=0;

int ithavemarks=0;

int signal_mark=0;


int page_indx[65536];
int num_pages=0;

int mark_indx[1024];
int num_marks=0;

int get_len_word(int pos)
{
int len=0;
if(text[pos]==0 || text[pos]==0xc3)  pos++;
while(text[pos]>32 && pos<len_text && len<39) {pos++;if(text[pos]==0 || text[pos]==0xc3)  pos++;len++;}
return len;
}

#define  WTEXT 8

void gen_index()
{
int x,y;
int n,m,l,k;
unsigned char cc;
int line;

// 20 caracteres por linea
x=0;
y=8;
n=0;m=0;

num_pages=0;line=0;
num_marks=0;
mark_indx[num_marks]=num_pages<<4;num_marks++;
page_indx[num_pages]=n;num_pages++;

text_cod=0;
if(text[n]==0xef) {n+=3;text_cod=1;} //UTF-8
if(text[n]==0xfe) {n+=3;text_cod=2;} //UTF-16
if(text[n]==0xff) {n+=2;text_cod=2;} //UTF-16
while(1)
	{

	if(n>=len_text) break;
	if(text[n]==0)  {n++;continue;}
	if(num_pages>65535) break;

	if(text[n]==10 || text[n]==13)
		{
		cc=text[n];
		n++;if(text[n]==0) n++;
		if(n<len_text)
			{
           while(text[n]!=cc && text[n]<32 && n<len_text) { n++;if(n>=len_text) break;if(text[n]==0) n++;if(n>=len_text) break;}
			}
		
            x=0;y+=16;
			line++;if(line>=14) {line=0;page_indx[num_pages]=n;num_pages++;}
			m=0;
		
		}
	else
		{
		if(text[n]==0xc3) {n++;continue;}
        if(text[n]=='[') // especial
			{
			int set=1;
			k=n+1;
            if(text[k]==0) k++;
			if(text[k]=='*') // marca de capitulo
				{
				k++;if(text[k]==0) k++;
				if(text[k]==']') 
					{
					k++;n=k;ithavemarks=1;
					mark_indx[num_marks]=((num_pages-1)<<4)+line;num_marks++;if(num_marks>=1024) num_marks=1023;
					continue;
					}
				}
			if(text[k]=='/') {set=0;k++;if(text[k]==0) k++;} // marca de fin
			if(text[k]=='r' || text[k]=='R') // marca de capitulo
				{
				k++;if(text[k]==0) k++;
				if(text[k]==']') 
					{
					k++;n=k;
					continue;
					}
				}
			else
			if(text[k]=='g' || text[k]=='G') // marca de capitulo
				{
				k++;if(text[k]==0) k++;
				if(text[k]==']') 
					{
					k++;n=k;
					continue;
					}
				}
			else
			if(text[k]=='b' || text[k]=='B') // marca de capitulo
				{
				k++;if(text[k]==0) k++;
				if(text[k]==']') 
					{
					k++;n=k;
					continue;
					}
				}

			}
		if(text[n]==9) {x+=WTEXT*4;n++;m=0;n++;}
		else 
        if(text[n]==32)
			{
			x+=WTEXT;n++;m=0;
			}
		else
			if(text[n]>32)
			{
			if(m==0)
				{
				l=get_len_word(n);
				l*=WTEXT;
				if((x+l)>=320) x=320; // si la palabra se sale de la pantalla, provoca un salto de linea
				m=1;
				}
			if(x<320) {x+=WTEXT;n++;}
			
			}
			else {n++;}
		if(x>=320) 
			{
		
		
            x=0;y+=16;line++;if(line>=14) {line=0;page_indx[num_pages]=n;num_pages++;}
			m=0;
			}

		}
	}

}
void display_page()
{
int x,y;
int n,m,l,k, exit1=1;
unsigned char cc;
unsigned char color=0;
int line;
int utf8=0;
// 20 caracteres por linea
x=0;
y=8;
n=pos_text;m=0;
signal_mark=0;
line=(cur_line/14)*14; // ajusta linea a pagina;
utf8=0;

if(n==0)
{
if(text[n]==0xef) {n+=3;} //UTF-8
if(text[n]==0xfe) {n+=3;} //UTF-16
if(text[n]==0xff) {n+=2;} //UTFl
}
while(exit1)
	{
	if(n>=len_text) break;
	if(text[n]==0)  {utf8=0;n++;continue;}
	if(text[n]==10 || text[n]==13)
		{
		cc=text[n];
		n++;if(text[n]==0) n++;
		if(n<len_text)
		{
          
		    while(text[n]!=cc && text[n]<32 && n<len_text) { n++;if(n>=len_text) break;if(text[n]==0) n++;if(n>=len_text) break;}
		}
		   
            x=0;
			if(line>=cur_line) y+=16;
			if(y>=232) {exit1=0;}
			m=0;
			line++;utf8=0;
		
		}
	else
		{
		if(text[n]==0xc3) {utf8=1;n++;continue;}
		 if(text[n]=='[') // especial
			{
			int set=1;
			k=n+1;
			utf8=0;
            if(text[k]==0) k++;
			if(text[k]=='*') // marca de capitulo
				{
				k++;if(text[k]==0) k++;
				if(text[k]==']') 
					{
					k++;n=k; // ignora la marca
					signal_mark=1;
					continue;
					}
				}
			if(text[k]=='/') {set=0;k++;if(text[k]==0) k++;} // marca de fin
			if(text[k]=='r' || text[k]=='R') // marca de capitulo
				{
				k++;if(text[k]==0) k++;
				if(text[k]==']') 
					{
					k++;n=k;
					if(set) color=1; else color=0;
					continue;
					}
				}
			else
			if(text[k]=='g' || text[k]=='G') // marca de capitulo
				{
				k++;if(text[k]==0) k++;
				if(text[k]==']') 
					{
					k++;n=k;
					if(set) color=2; else color=0;
					continue;
					}
				}
			else
			if(text[k]=='b' || text[k]=='B') // marca de capitulo
				{
				k++;if(text[k]==0) k++;
				if(text[k]==']') 
					{
					k++;n=k;
					if(set) color=3; else color=0;
					continue;
					}
				}

			}
		if(text[n]==9) {x+=WTEXT*4;n++;m=0;n++;utf8=0;} // TAB
		else 
        if(text[n]==32) //SPACE
			{
			x+=WTEXT;n++;m=0;utf8=0;
			}
		else
			if(text[n]>32)
			{
			if(m==0)
				{
				l=get_len_word(n);
				l*=WTEXT;
				if((x+l)>=320) x=320; // si la palabra se sale de la pantalla, provoca un salto de linea
				m=1;
				}
			if(x<320) {if(line>=cur_line)t_putchar(x,y,color,(utf8==0) ? text[n]: text[n]+0x40);x+=WTEXT;n++;utf8=0;}
			
			}
			else {n++;}
		if(x>=320) 
			{
		   
            x=0;
			if(line>=cur_line) y+=16;
			if(y>=232) {exit1=0;}
			line++;
			m=0;
			}

		}
	}

if(n>=len_text)
	{
	if(cur_line>line) cur_line=line;
	}

}


char cad[256];


void set_backcolor(int n)
{
int factor;
if(n==0) {background[0]=255;background[1]=255;background[2]=255;}
if(n==1) {background[0]=255;background[1]=255;background[2]=180;}
if(n==2) {background[0]=200;background[1]=200;background[2]=200;}
if(n==3) {background[0]=200;background[1]=200;background[2]=140;}

set_mypalette();
}


char filename[256];

char file_opt[20][256];
int file_pos[20];
int file_num=0;

void read_cfg()
{
FILE *fp;

unsigned char str_buf[512];


file_num=0;

fp=fopen("/mnt/sd/textread/textread.cfg","r");
if(fp==0) return;

while(1)
	{
	if(fgets(str_buf,512,fp)==0) break;
    if(sscanf(str_buf,"Entry %u,%s",&file_pos[file_num],&file_opt[file_num][0])==2) 
		   {
		   if(file_pos[file_num]>=0)  file_num++;
		   }
		
	   

	}
fclose(fp);
}


void locate_in_cfg()
{
int n;
for(n=0;n<file_num;n++)
	{
	if(!strcmp(filename,&file_opt[n][0])) {cur_page=file_pos[n];break;}
	}
if(cur_page<0 || cur_page>=num_pages) cur_page=0;
}


void write_cfg()
{
FILE *fp;
int n,m;



for(n=0;n<file_num;n++)
	{
	if(!strcmp(filename,&file_opt[n][0])) break;
	}
if(n==file_num) // no existe esta entrada;
	{
	if(n<20) {strcpy(&file_opt[file_num][0],filename);file_pos[file_num]=cur_page;file_num++;}
	else {for(n=0;n<19;n++) {strcpy(&file_opt[n][0],&file_opt[n+1][0]);file_pos[n]=file_pos[n+1];}
	      strcpy(&file_opt[n][0],filename);file_pos[n]=cur_page;
		  }

	}
else
	{
	for(;n<(file_num-1);n++)
		{
		strcpy(&file_opt[n][0],&file_opt[n+1][0]);file_pos[n]=file_pos[n+1];
		}
    
	strcpy(&file_opt[n][0],filename);file_pos[n]=cur_page;
	}

for(n=0;n<3;n++)
{
if(rename("/mnt/sd/textread/textread.bak","/mnt/sd/textread/textread.cfg")<0)
	{
	remove("/mnt/sd/textread/textread.bak");
	} else break;
}
sync();
fp=fopen("/mnt/sd/textread/textread.cfg","w");
if(fp==0) return;
for(n=0;n<file_num;n++)
	{
	fprintf(fp,"Entry %u,%s\n",file_pos[n],&file_opt[n][0]);
	}
fclose(fp);
sync();



}
#ifdef USE_ZIP


int zip_load(char *name)
{
 struct zip *za;
 struct zip_file * fp;
 struct zip_stat st;

 int n,m,idx;
    int err;
 if ((za=zip_open(name, 0, &err)) == NULL)     return -1;
 m= zip_get_num_files(za);
 if(m<=0) {zip_close(za);return -2;}
 
 
 for(idx=0;idx<m;idx++)
	{

	 zip_stat_index(za, idx , 0, &st);
	if(( // busca un txt valido
	is_ext(st.name,".txt") ||is_ext(st.name,".TXT")
			
	 ))  break;
	
     }
  if(idx==m) {zip_close(za);return -2;}
 
len_text=st.size;
 //st.crc;
text=malloc(len_text+128);
if(!text) {zip_close(za);return -33;}
fp=zip_fopen_index(za, idx,0);

m=0;
while(1)
	{
     n=zip_fread(fp,text+m,len_text-m);
	if(n>0) m+=n; else break;
	}
if(n<0 || m!=len_text) len_text=0;
zip_fclose(fp);
zip_close(za);
return 0;
}

#endif

int main(int argc, char *argv[])
{
int i,r,n,ret,updatev;
int r1,r2,r11,r21,r3,r4; // usadas en autorepeticion de botones
int salt;
int backcolor=0;

unsigned time;

FILE *fp;
int count_fps=0;

#ifdef DEBUG_MSG
printf("Iniciando textreader\n");
#endif

gp2x_init(1000,8,ds_nSampleRate,ds_nBits,ds_nChannels==2,50,1);


cpuctrl_init();  // ATENCION: si no se hace esto, cuelgue seguro (aprovecho la definicion de rlyeh y debe ir despues de gp2x_init)
Disable_940(); // desconecta el 940t
save_system_regs();
dclock=get_display_clock_div();
gp2x_speed=66;
set_speed_clock();


mount("-t vfat -o remount,sync,iocharset=utf8 /dev/mmcsd/disc0/part1 /mnt/sd");
mkdir("/mnt/sd/textread",S_IREAD | S_IWRITE);



read_cfg();

credits();

while(1)
{
if(text) free(text); text=0;
r=get_file();
if(r==-1) goto me_voy_de_aqui;

if(path_file[0]!=0) sprintf(filename, "%s%s/%s",device ,path_file,&files[r][0]); // generando el nombre del fichero
else sprintf(filename, "%s%s",device, &files[r][0]);

backcolor=3;
set_backcolor(backcolor);
num_pages=0;num_marks=0;ithavemarks=0;
page_indx[cur_page]=0;len_text=0;


gp2x_speed=200; // pon velocidad de busqueda
set_speed_clock();

len_text=0;
#ifdef USE_ZIP
if(is_ext (filename, ".zip") || is_ext (filename, ".ZIP"))
	{
	zip_load(filename);
	}
else
	{
#endif


fp=fopen(filename,"r"); // lee el fichero de texto
if(fp!=0)
{
fseek(fp,0,SEEK_END);
len_text=ftell(fp);
fseek(fp,0,SEEK_SET);
text=malloc(len_text+128);
if(text) 
	{n=fread(text,1,len_text,fp);
    if(n<0) {len_text=0;free(text);text=0;} else len_text=n;
	}
else len_text=0;
fclose(fp);
}
#ifdef USE_ZIP
	}
#endif
if(text && len_text) // genera las tablas de indices del texto
	{
	gen_index();
	}

gp2x_speed=66; // pon velocidad de lectura
set_speed_clock();

COLORFONDO=255;
ClearScreen(COLORFONDO);gp2x_video_waitvsync();
gp2x_video_RGB_flip(0);
ClearScreen(COLORFONDO);gp2x_video_waitvsync();
gp2x_video_RGB_flip(0);

 
pos_text=0;
cur_page=0;
cur_mark=0;

r1=0;r2=0;r11=0;r21=0;salt=1;
r3=r4=0;


locate_in_cfg(); //  busca si se grab marca de posicin para este fichero

if(ithavemarks) // busca la marca de texto
	{
	for(n=0;n<num_marks;n++)
		{
		if(cur_page<=(mark_indx[n]>>4))
			{
			cur_mark=n;break;
			}

		}
	}

cur_line=cur_page*14;
updatev=1;

oldtime=gp2x_timer_read();// lee el tiempo (cada minuto se salva automaticamente)

while(1)
{
gp2x_video_waitvsync();

if(updatev)
{

ClearScreen(COLORFONDO);

if(!text) break;


// cabecera
COLORFONDO=254;
sprintf(cad,"Pagina %u/%u           ",(cur_page)+1,(num_pages));
v_putcad(0,0,3,cad);
v_putcad(20,0,3,"TextReader by Hermes");
COLORFONDO=255;

//texto
pos_text=page_indx[cur_page];
display_page();
if(signal_mark){for(n=0;n<num_marks;n++)	{if(cur_page<=(mark_indx[n]>>4)){cur_mark=n;break;}}}
signal_mark=0;

updatev=0;gp2x_video_RGB_flip(0);
}
else
	{
	n=0x7ffff;while(n) n--; // rutina de carga
	}

  
  gp2x_nKeys=gp2x_joystick_read();
	
	new_key=gp2x_nKeys & (~old_key);
	old_key=gp2x_nKeys;

    if(old_key & GP2X_UP) {r3++;;if(r3>25) {r3=24;new_key|=GP2X_UP;}} else {r3=0;}
	if(old_key & GP2X_DOWN) {r4++;if(r4>25) {r4=24;new_key|=GP2X_DOWN;}} else {r4=0;}

	if(old_key & GP2X_A) {r1++;r11++;if(r1>25) {r1=24;new_key|=GP2X_A;}} else {r1=0;r11=0;salt=1;}
	if(old_key & (GP2X_B | GP2X_R)) {r2++;r21++;if(r2>25) {r2=24;new_key|=GP2X_B;}} else {r2=0;r21=0;salt=1;}

	if(r11>25*10 || r21>25*10) salt=10;

    if(ithavemarks==1 && (old_key & GP2X_L)) // salto de marca
    {
	if(new_key & GP2X_A) {updatev=1;cur_mark-=1;if(cur_mark<0) cur_mark=0;cur_page=mark_indx[cur_mark]>>4;cur_line=cur_page*14+(mark_indx[cur_mark] & 15);}
	if(new_key & GP2X_B) {updatev=1;cur_mark+=1;if(cur_mark>=num_marks) cur_mark=num_marks-1;if(cur_mark<0) cur_mark=0;cur_page=mark_indx[cur_mark]>>4;cur_line=cur_page*14+(mark_indx[cur_mark] & 15);}
	}
    else
	{  // salto de pagina
	if(new_key & GP2X_A) {updatev=1;cur_page-=salt;if(cur_page<0) {cur_page=0;cur_line=0;} cur_line=(cur_page*14)+(cur_line % 14);}
	if(new_key & (GP2X_B | GP2X_R)) {updatev=1;cur_page+=salt;if(cur_page>=num_pages) cur_page=num_pages-1;if(cur_page<0) cur_page=0;cur_line=(cur_page*14)+(cur_line % 14);}
	}

	// salto de linea
    if(new_key & GP2X_UP) {updatev=1;cur_line--;if(cur_line<0) cur_line=0;cur_page=cur_line/14;}
	if(new_key & GP2X_DOWN) {updatev=1;cur_line++;if(cur_line>=(num_pages*14)) cur_line=(num_pages*14)-1;if(cur_line<0) cur_line=0;cur_page=cur_line/14;}

	if(new_key & GP2X_Y) {backcolor++;backcolor&=3;set_backcolor(backcolor);}

   
	if(new_key & GP2X_SELECT) {write_cfg();break;}
	if((old_key & GP2X_L) && (new_key & GP2X_START)) {updatev=1;cur_page=0;cur_line=0;if(ithavemarks){for(n=0;n<num_marks;n++)	{if(cur_page<=(mark_indx[n]>>4)){cur_mark=n;break;}}}
	                          
							  }

time=gp2x_timer_read(); // salva cada 60 segundos la posicion del texto
if((time-oldtime)>60000) {write_cfg();oldtime=time;}

	
}

}
me_voy_de_aqui:

if(text) free(text); text=0;

gp2x_speed=200;
set_speed_clock();
set_display_clock_div(dclock);
ClearScreen(0);
gp2x_video_RGB_flip(0);
ClearScreen(0);
gp2x_video_RGB_flip(0);

gp2x_sound_pause(1) ;gp2x_sound_volume(0,0);

load_system_regs();

gp2x_deinit();
return(0);

}
